// SNF4CGP/ConfigurationEngine.cpp
// Copyright (C) 2009 ARM Research Labs, LLC
// See www.armresearch.com for more information.

#include "ConfigurationEngine.hpp"
#include "..\SNFMulti\SNFMulti.hpp"

using namespace std;

ConfigurationManager::ConfigurationManager(snf_RulebaseHandler& R) :
      Rulebase(R),
      Generation_(0),
      Configurations(ResultConfigurationSize) {
          for(size_t i = 0; i < Configurations.size(); i++) {
              Configurations[i].ResultCode = i;
          }
    }

bool ConfigurationManager::isOutOfDate() {
    return (Generation_ != Rulebase.Generation());
}

void ConfigurationManager::update() {
}

const int OutOfRangeDefaultCode = 0;

ResultConfiguration& ConfigurationManager::ConfigurationForResultCode(int Code) {
    if(0 > Code || HighestResultCode < Code) Code = OutOfRangeDefaultCode;
    return Configurations[Code];
}

